import { TSFusionEnumeration } from "./tsfusionnode";
import { Nullable } from "./types";
export declare function $mapset<T, R = T>(values: Nullable<Iterable<T>>, callback: (value: T, index: number) => Nullable<R>): Set<R>;
export declare function $map<T, R = T>(values: Nullable<Iterable<T>>, callback: (value: T, index: number) => Nullable<R>): R[];
export declare function $first<T = any>(values: Nullable<ArrayLike<T>>): T | undefined;
export declare function $last<T = any>(values: Nullable<ArrayLike<T>>): T | undefined;
export declare function $sum<T = any>(values: Nullable<Iterable<T>>): number | undefined;
export declare function $min<T = any>(values: Nullable<Iterable<T>>): T | undefined;
export declare function $max<T = any>(values: Nullable<Iterable<T>>): T | undefined;
export interface $averageOptions {
    countsOnlyOKItems?: boolean;
    countsOnlyDefinedItems?: boolean;
}
export declare function $average<T = any>(values: Nullable<Iterable<T>>, opts?: $averageOptions): number | undefined;
declare global {
    export interface Array<T> extends TSFusionEnumeration {
        average: (this: T[], opts?: $averageOptions) => number | undefined;
        filteredMap: <R = T>(this: T[], callback: (value: T, index: number) => Nullable<R>) => R[];
        filteredSet: <R = T>(this: T[], callback: (value: T, index: number) => Nullable<R>) => Set<R>;
        first: (this: T[]) => T | undefined;
        last: (this: T[]) => T | undefined;
        max: (this: T[]) => T | undefined;
        min: (this: T[]) => T | undefined;
        sum: (this: T[]) => number | undefined;
    }
}
