/// <reference types="node" />
import { Bytes, Nullable, TSDataLike, TSEndianness } from "./types";
type _TSHashFunction = (hashBlock: number[]) => void;
interface _TSHashBufferOptions {
    integersCount: number;
    endianness?: TSEndianness;
    padding?: Nullable<Bytes>;
    separator?: Nullable<string>;
    dataoutput?: Nullable<boolean>;
}
export declare class _TSHashBuffer {
    readonly sourceLength: number;
    readonly blocksCount: number;
    readonly blockSize: number;
    readonly intCount: number;
    readonly paddingLength: number;
    readonly separator?: Nullable<string>;
    readonly dataoutput?: Nullable<boolean>;
    private _endianness;
    private _block;
    private _source?;
    private _padding?;
    private _ret;
    constructor(buf: Nullable<TSDataLike>, opts: _TSHashBufferOptions);
    private _getBlock;
    hash(fn: _TSHashFunction, printBlocks?: Nullable<boolean>): void;
    output(h: number[]): Buffer | string;
}
export {};
