/// <reference types="node" />
import { Bytes, Nullable, TSDataLike, uint8 } from "./types";
export interface DataConversionOptions {
    start?: Nullable<number>;
    end?: Nullable<number>;
    forceCopy?: Nullable<boolean>;
}
export declare function $bufferFromArrayBuffer(a: ArrayBuffer): Buffer;
export declare function $bufferFromBytes(source: Bytes, opts?: DataConversionOptions): Buffer;
export declare function $bufferFromDataLike(source: TSDataLike, options?: DataConversionOptions): Buffer;
export { $bufferFromArrayBuffer as $uint8ArrayFromArrayBuffer };
export declare function $uint8ArrayFromBytes(source: Bytes, opts?: DataConversionOptions): Uint8Array;
export declare function $uint8ArrayFromDataLike(source: TSDataLike, options?: DataConversionOptions): Uint8Array;
export { $bufferFromArrayBuffer as $bytesFromArrayBuffer };
export declare function $bytesFromDataLike(source: TSDataLike, opts?: DataConversionOptions): Bytes;
export declare function $arrayFromBytes(source: Bytes, opts?: DataConversionOptions): uint8[];
export declare function $arrayFromDataLike(source: TSDataLike, options?: DataConversionOptions): uint8[];
export declare function $arrayBufferFromBytes(source: Bytes, opts?: DataConversionOptions): ArrayBuffer;
export declare function $arrayBufferFromDataLike(source: TSDataLike, opts?: DataConversionOptions): ArrayBuffer;
export declare function $decodeBase64(input: string, reference?: string): Uint8Array;
export declare function $encodeBase64(source: Uint8Array | string, reference?: string): string;
interface $bufferAspectOptions {
    prefix?: string;
    suffix?: string;
    name?: string;
    separator?: string;
    showLength?: boolean;
    transformFn?: (n: number) => string;
}
export declare function $dataAspect(source: Bytes | Uint16Array | Uint32Array, opts?: $bufferAspectOptions): string;
declare global {
    export interface String {
        toBase64: (this: string) => string;
    }
    export interface Uint8Array {
        leafInspect: (this: Uint8Array) => string;
        toBase64: (this: Uint8Array) => string;
        isGenuineUint8Array: (this: Uint8Array) => boolean;
    }
    export interface Uint16Array {
        leafInspect: (this: Uint16Array) => string;
    }
    export interface Uint32Array {
        leafInspect: (this: Uint32Array) => string;
    }
    export interface ArrayBuffer {
        leafInspect: (this: any) => string;
        toBase64: (this: any) => string;
    }
}
export declare function _toBytesOpts(source: TSDataLike, opts?: DataConversionOptions): [Bytes, DataConversionOptions];
