"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$timeBetweenDates = void 0;
const commons_1 = require("./commons");
const tsdate_1 = require("./tsdate");
function $timeBetweenDates(a, b) {
    a = (0, commons_1.$ok)(a) ? a : tsdate_1.TSDate.past();
    b = (0, commons_1.$ok)(b) ? b : tsdate_1.TSDate.future();
    if (a instanceof Date && b instanceof Date) {
        return b.timeSinceDate(a);
    }
    if (!(a instanceof tsdate_1.TSDate)) {
        a = new tsdate_1.TSDate(a);
    }
    if (!(b instanceof tsdate_1.TSDate)) {
        b = new tsdate_1.TSDate(b);
    }
    return b.timeSinceDate(a);
}
exports.$timeBetweenDates = $timeBetweenDates;
Date.prototype.leafInspect = Date.prototype.toISOString;
Date.prototype.timeSinceDate = function timeSinceDate(other) { return (this.getTime() - other.getTime()) / 1000; };
Date.prototype.toTSDate = function toTSDate() { return tsdate_1.TSDate.fromDate(this); };
Date.prototype.toDate = function toDate() { return this; };
//# sourceMappingURL=date.js.map