"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TSTrace = exports.TSTracer = void 0;
const array_1 = require("./array");
const commons_1 = require("./commons");
const utils_1 = require("./utils");
class TSTracer {
}
exports.TSTracer = TSTracer;
TSTracer.index = 0;
TSTracer.originalLog = (s) => (0, utils_1.$logterm)(s);
TSTracer.originalWrite = (s) => (0, utils_1.$writeterm)(s);
TSTracer.log = TSTracer.originalLog;
TSTracer.write = TSTracer.originalWrite;
function TSTrace(target, name, descriptor) {
    const property = descriptor.value;
    if ((0, commons_1.$isfunction)(property)) {
        descriptor.value = function (...args) {
            const tracerIndex = TSTracer.index++;
            TSTracer.log('&0');
            TSTracer.log(`&l---- trace &y${tracerIndex} &l----`);
            TSTracer.write(`&o${target.constructor.name}&w.&p${name}&w(&c${(0, commons_1.$count)(args) ? (0, array_1.$map)(args, (a) => (0, utils_1.$inspect)(a)).join('&w, &c') : ''}&w) `);
            try {
                const res = property.apply(this, args);
                TSTracer.log(`= &j${(0, utils_1.$inspect)(res)}&0`);
                TSTracer.log(`&l---- did trace &o${tracerIndex}&l ----&0`);
                return res;
            }
            catch (e) {
                TSTracer.log(`&R&w did encounter error ${e} &0`);
                throw e;
            }
        };
    }
    return descriptor;
}
exports.TSTrace = TSTrace;
//# sourceMappingURL=decorators.js.map