import { TSDate } from "./tsdate";
import { int, Nullable, uint } from "./types";
export declare function $ascii(source: Nullable<string>): string;
export declare function $ltrim(s: Nullable<string>): string;
export declare function $rtrim(s: Nullable<string>): string;
export declare function $ftrim(s: Nullable<string>): string;
export { $ftrim as $trim };
export declare function $left(source: Nullable<string>, leftPart?: Nullable<number>): string;
export declare function $right(source: Nullable<string>, rightPart?: Nullable<number>): string;
export declare function $lines(s: Nullable<string>, useOnlyASCIISeparators?: boolean): string[];
export declare function $normspaces(s: Nullable<string>): string;
export declare function $firstcap(s: Nullable<string>): string;
export declare function $capitalize(s: Nullable<string>): string;
export declare function $HTML(s: Nullable<string>, reference?: string[]): string;
export declare class HTMLContent extends String {
}
declare global {
    export interface String {
        ascii: (this: string) => string;
        capitalize: (this: string) => string;
        firstCap: (this: string) => string;
        ftrim: (this: string) => string;
        left: (this: string, leftPart?: Nullable<number>) => string;
        isDate: (this: string) => boolean;
        isEmail: (this: string) => boolean;
        isNewLine: (this: string) => boolean;
        isStrictWhiteSpace: (this: string) => boolean;
        isUrl: (this: string) => boolean;
        isUUID: (this: string) => boolean;
        isWhiteSpace: (this: string) => boolean;
        lines: (this: string, useOnlyASCIISeparators?: boolean) => string[];
        ltrim: (this: string) => string;
        normalizeSpaces: (this: string) => string;
        right: (this: string, rightPart?: Nullable<number>) => string;
        rtrim: (this: string) => string;
        singular: (this: string) => boolean;
        toDate: (this: string) => Date | null;
        toHTML: (this: string) => string;
        toHTMLContent: (this: string) => HTMLContent;
        toInt: (this: string, defaultValue?: int) => int;
        toTSDate: (this: string) => TSDate | null;
        toUnsigned: (this: string, defaultValue?: uint) => uint;
    }
    export interface HTMLContent {
        toHTML: (this: any) => string;
    }
}
