import { Locales } from './tsdefaults';
import { TSClone, TSLeafInspect, TSObject } from './tsobject';
import { Comparison, country, currency, language, Nullable, StringTranslation } from './types';
declare const customInspectSymbol: unique symbol;
export declare class TSCountry implements TSObject, TSLeafInspect, TSClone<TSCountry> {
    private static __countriesMap;
    private static __countries;
    private static __EULocale;
    readonly alpha2Code: country;
    readonly alpha3Code: string;
    readonly names: StringTranslation;
    readonly spokenLanguages: language[];
    readonly domains: string[];
    readonly EEC: boolean;
    readonly dialCode: string;
    readonly currency: currency;
    readonly locales: Locales;
    private constructor();
    static loadCountries(localesMap: Map<string, Locales>, managedLanguages: language[]): void;
    static country(c: Nullable<country | string>): TSCountry | null;
    static countries(): TSCountry[];
    get name(): string;
    get label(): string;
    get language(): language;
    get languageName(): string;
    clone(): TSCountry;
    translatedName(lang?: Nullable<language>): string | null;
    toString(): string;
    toJSON(): any;
    toArray(): string[];
    isEqual(other: any): boolean;
    compare(other: any): Comparison;
    leafInspect(): string;
    [customInspectSymbol](depth: number, inspectOptions: any, inspect: any): string;
}
export {};
