import { TSLeafInspect } from "./tsobject";
import { Resp } from "./tsrequest";
import { Nullable, TSDictionary } from "./types";
export declare class TSUniqueError extends Error implements TSLeafInspect {
    private static __timeoutInstance;
    private static __genericInstance;
    private constructor();
    static genericError(): TSUniqueError;
    static timeoutError(): TSUniqueError;
    leafInspect(): string;
}
export declare class TSError extends Error {
    readonly info: TSDictionary | undefined;
    private _errorCode;
    constructor(message: string, info?: Nullable<TSDictionary>, errorCode?: Nullable<number>);
    static assertIntParam(v: Nullable<number>, fn: string, param: string): void;
    static assertNotInBrowser(fn: string): void;
    static assertUnsignedParam(v: Nullable<number>, fn: string, param: string): void;
    get errorCode(): Nullable<number>;
    set errorCode(code: Nullable<number>);
    entries(): [string, any][];
}
export declare function $subclassReponsabililty(instance: object, method: Function): any;
export declare class TSHttpError extends TSError {
    readonly status: Resp;
    constructor(message: string, status: Resp, info?: Nullable<TSDictionary>, errorCode?: Nullable<number>);
    entries(): [string, any][];
}
